Academy = {
	model: null,
	page: 1,
	pages: 0,
	initialized: false,
	adsInterval: 3,
	init: function()
	{
		if(this.initialized)
		{
			this.reset();
			return;
		}
		this.initialized = true;

		var self = this;

		App.setTitle("Academy");

		this.model = $(".academy .feed-item");
		this.model.remove();
		
		$(".academy .btn-more").hide().click(function() {
			self.loadMore();
		});

		this.get();
	},
	reset: function()
	{
		$(".academy .feed-container").html("");
		this.get();
	},
	get: function()
	{
		App.showPreLoader();

		var self = this;
		Svc.get(SITE_URL + "academy?json=1&page=" + this.page, function(data) {
			self.getResult(data);
		});
	},
	getResult: function(rs)
	{
		var self = this;

		App.hidePreLoader();

		this.pages	= rs.total;
		if(this.pages > 1 && this.pages != this.page)
			$(".academy .btn-more").show().attr("disabled", null);
		else
			$(".academy .btn-more").hide();

		var arr		= rs.data;
		var it, img, data;
		for(var i = 0; i < arr.length; i++)
		{
			data = arr[i];

			it = this.model.clone().show();
			it.find("header > a").attr("href", "user.html?uid=" + data.owner_id);
			it.find("header span").html(data.owner_fname);
			it.find("header .dt").html(data.dt);
			it.find("header img").attr("src", UPLOAD_URL + "profile/a" + (data.owner_id % 20) + "/" + data.owner_id + "-1.jpg");
			it.find(".description").html(data.title);
			
			//it.find("article > a").attr("href", "academy-view.html?uid=" + data.id);

			var url = data.video_url;
			if(url.indexOf("vzaar") != -1)
			{
				
				url = url.split("vzaar:").join("");
				/*
				it.find("article > a").attr("href", "http://view.vzaar.com/"+ url +".video").attr("target", "cvideo");
				*/
				
				
				
				var iframe = $('<iframe class="c-video c-video-vzaar" name="c-video-'+ data.id +'" frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen data-role="none"></iframe>');
				iframe.css("opacity", 0.3);
				iframe.css("margin-left", -15);
				//it.find("article > a").remove();
				it.find("article").prepend(iframe);
				
				//it.find("article > a").attr("href", "http://view.vzaar.com/"+ url +".video").attr("target", "c-video-" + data.id);
				iframe.attr("src", "http://view.vzaar.com/"+ url +".video");

				
				it.find("article > a > img").attr("data-id", data.id).load(function() {
					var i = $("iframe[name='c-video-"+ $(this).attr("data-id") +"']");
					i.width($(this).width());
					i.height($(this).height());
				});
				it.find("article > a > img").attr("src", UPLOAD_URL + "academy/" + data.filepath + "-3.jpg");
				//iframe.attr("src", "http://view.vzaar.com/"+ url +"/player");

			} else {
				var iframe = $('<iframe class="c-video" frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen data-role="none"></iframe>');
				it.find("article > a").remove();
				it.find("article").prepend(iframe);
				iframe.attr("src", "http://www.youtube.com/embed/"+ url + "?rel=0&autoplay=0");
			}

			$(".academy .feed-container").append(it);

			this.buildAds();
		}

	},
	buildAds: function()
	{
		if(!App.adsData) return;
		var self = this;

		var i = 0;
		$(".academy .feed-container").children().each(function() {
			if($(this).hasClass("feed-item"))
			{
				i++;
				if(i == self.adsInterval && !$(this).next().hasClass("ads"))
				{
					var ads = $("<div class='ads'></div>");
					$(this).after(ads);
					i = 0;
				}
			} else {
				i = 0;
			}
		});

		var adsIndex	= -1;
		var adsLen		= App.adsData.length;
		$(".academy .feed-container .ads").each(function() {
			var index = parseInt($(this).attr("index"));
			if(isNaN(index))
			{
				index		= adsIndex + 1;
				adsIndex	= index >= adsLen ? 0 : index;
				$(this).html("<a href='"+ App.adsData[adsIndex].url +"'><img src='"+ SITE_URL +"assets/ads/"+ App.adsData[adsIndex].id +".jpg'></a>");
			} else {
				adsIndex = index;
			}
		});
	},
	playVideo: function(url)
	{
		
		if(url.indexOf("vzaar") != -1)
		{
			url = url.split("vzaar:").join("");
			$("#c-video").attr("src", "http://view.vzaar.com/"+ url +"/player?autoplay=true");
		} else {
			$("#c-video").attr("src", "http://www.youtube.com/embed/"+ url + "?autoplay=1");
		}
	},
	loadMore: function()
	{
		this.page = Math.min(this.pages, this.page + 1);
		$(".academy .btn-more").attr("disabled", "disabled");
		this.get();
	}
}