this.Comments = {
	cmModel: null,
	total:	0,
	count:	0,
	cursor: null,
	page: null,
	loading: false,
	contentId: 0,
	loadCallBack: null,
	init: function(contentId, page, loadCallBack)
	{
		this.contentId	= contentId;
		this.page		= page;
		this.loadCallBack = loadCallBack;
		this.cmModel	= $(".comment").remove().clone();

		setTimeout(function() {
			$(window).trigger( "resize" );
		}, 400);
		this.load();
		this.bindEvents();
	},
	reset: function()
	{
		this.total = this.count = 0;
		this.cursor = null;
		$(".comment-list").html("");
	},
	bindEvents: function() {
		var self = this;
		this.updateCharCount(0);

		$(".input-txt-comment").keyup(function() {
			self.updateCharCount($(this).val().length);
			$(this).val($(this).val().substr(0, 300));
			$(window).trigger( "resize" );
		});
		$(".input-txt-comment").blur(function() {
			$(window).trigger( "resize" );
		});
		$(".comment-form .btn").click(function() {
			self.post();
		});
		$(".btn-load-more-comments").click(function() {
			self.load();
		});
	},
	load: function() {
		if(this.loading || (this.count >= this.total && this.total > 0)) return;

		var self = this;
		if(!this.contentId)
		{
			try {
				console.log("Comments.load/invalid content ID");
			} catch (e) { }
			return;
		}

		//$(".comment-list").html("");

		this.loading = true;

		App.showPreLoader();


		Svc.get(SITE_URL + this.page + '/getByContent/' + this.contentId + '/' + (this.cursor ? this.cursor : ""), function( data ) {
			self.total	= data.total;
			self.count  += data.data.length;

			var commentsLeft = self.total - self.count;
			$(".btn-load-more-comments").css("display", commentsLeft ? "block" : "none");
			$(".btn-load-more-comments").find(".circle-counter").html("+" + commentsLeft);
			
			data = data.data;
			for(var i = 0; i < data.length; i++)
				self.append(data[i]);


			self.loading = false;

			if(self.total < 1 && !$(".input-txt-comment").val())
				$(".input-txt-comment").attr("placeholder", "Seja o primeiro a comentar").focus();

			if(self.loadCallBack)
			{
				self.loadCallBack();
				self.loadCallBack = null;
			}

			$(window).trigger( "resize" );

		});
	},
	append: function(vo, isNew) {
		if(!isNew)
			this.cursor = vo._id;

		var it = this.cmModel.clone();
	
		it.attr("data-id", vo._id);

		it.find("a").attr("href", "user.html?username=" + vo.user_name);
		if(vo.dt)
			it.find(".dt").html(vo.dt);
		it.find(".fname").html(vo.user_fname);
		it.find("article").html(vo.comment);
		it.find("img").attr("src", UPLOAD_URL + "profile/" + vo.avatar);

		/*
		if(vo.user_id == userId)
			it.find(".btn-remove").click(function() {
					Comments.removeComment($(this).parent().parent().attr("data-id"));
				});
		else
			it.find(".btn-remove").remove();

		it.find(".btn-flag").click(function() {
			Denounce.request($(this).parent().parent().attr("data-id"), 'comment');
		});

		it.hover(function() {
			$(this).find(".actions").show();
		}, function() {
			$(this).find(".actions").hide();
		});
		*/
		
		var container = $(".comment-list");

		container.prepend(it);
	},
	removeComment: function(id) {
		if(!id) return;
		
		Svc.get(this.page + '/remove/' + id, function(data) {
			if(data.status > 0)
				$(".it-comment[data-id="+ id + "]").fadeTo(0, .3);
			else
				alert("Error:" + data.status);
		});
	},
	updateCharCount: function(n)
	{
		$(".comment-form").find(".char-count").html(n + "/" + $(".input-txt-comment").attr("maxlength"));
	},
	enable: function(value) {
		if(value !== false)
			value = true;

		//$(".comment-form textarea").attr("disabled", value ? null : "disabled");
		$(".comment-form .btn").attr("disabled", value ? null : "disabled");
	},
	post: function() {
		if(!App.userId)
		{
			App.openLogin();
			return;
		}

		var cm = $(".input-txt-comment").val();
		if(cm.length < 2) return;

		var self = this;
		this.enable(false);

		

		Svc.post(SITE_URL + this.page + '/create', {id: parseInt(this.contentId), comment: cm}, function(data) {
			if(data.status > 0)
				self.append(data.vo, true);
			else
				alert("Error:" + data.status);

			$(".comment-form textarea").val('').attr("placeholder", "");
			self.updateCharCount(0);
			self.enable();
	

			$(".comment-list").scrollTop(0);
		});
	}
}

Comment = {
	id: 0,
	page: "",
	initialize: false,
	init: function()
	{
		this.id		= App.getParam("id");
		this.page	= App.getParam("page");

		
		if(this.initialized)
		{
			Comments.contentId	= this.id;
			Comments.page		= this.page;
			Comments.reset();
			Comments.load();
		} else {
			this.initialized = true;
			Comments.init(this.id, this.page, function()
			{
				App.hidePreLoader();
			});
		}
		//$(".comments").show();

		App.setTitle("Comentários");
	}
}