Feed = {
	model: null,
	userModel: null,
	searchBy: null,
	page: 1,
	pages: 0,
	initialized: false,
	adsData: null,
	adsInterval: 5,
	busy: false,
	ready: false,
	init: function()
	{
		App.setTitle("Feed");

		if(this.initialized)
		{
			this.reset();
			return;
		}
				

		this.model = $(".feed .feed-item");
		this.model.remove();

		this.userModel = $(".feed .row-user");
		this.userModel.remove();

		this.ready = true;

		this.getAds();

		this.reset();

		this.initialized = true;

		//this.get();
	},
	bindEvents: function()
	{
		if(this.initialized) return;

		var self = this;

		$(".feed .btn-more").hide().click(function() {
			self.loadMore();
		});

		$(".feed .btn-more").hide().click(function() {
			self.loadMore();
		});

		$(".feed .search-form .clean-bt").click(function() {
			$(this).parent().find(".search-input").val("");
		});

		$(".feed .search-form .search-input").focus(function() {
			$(this).parent().find(".clean-bt").show();
		}).blur(function() {
			if(!$(this).val())
				$(this).parent().find(".clean-bt").hide();
		});


		$(".feed .search-form").submit(function(e) {
			e.preventDefault();
			self.page	= 1;
			self.pages	= 1;
			self.search();
		});

		//search
		$(".feed .btn-group li").click(function() {
			$(".feed .btn-group li").removeClass("selected");
			$(this).addClass("selected");
			self.page	= 1;
			self.pages	= 1;
			self.search();
		});
	},
	reset: function()
	{
		App.setTitle("Feed");

		if(!this.ready) return;

		this.busy = false;

		$(".feed .btn-more").hide();

		$(".feed .feed-container").html("");

		this.searchBy = null;
		this.page = 1;
		this.pages = 0;

		this.bindEvents();

		this.get();
	},
	getAds: function()
	{
		var self = this;
		Svc.get(SITE_URL + "ads/mobile", function(data) {
			self.getAdsResult(data);
		});
	},
	getAdsResult: function(data)
	{
		this.adsData = App.adsData = data;

		this.buildAds();
	},
	buildAds: function()
	{
		if(!this.adsData) return;
		var self = this;

		var i = 0;
		$(".feed .feed-container").children().each(function() {
			if($(this).hasClass("feed-item"))
			{
				i++;
				if(i == self.adsInterval && !$(this).next().hasClass("ads"))
				{
					var ads = $("<div class='ads'></div>");
					$(this).after(ads);
					i = 0;
				}
			} else {
				i = 0;
			}
		});

		var adsIndex = -1;
		var adsLen = this.adsData.length;
		$(".feed .feed-container .ads").each(function() {
			var index = parseInt($(this).attr("index"));
			if(isNaN(index))
			{
				index		= adsIndex + 1;
				adsIndex	= index >= adsLen ? 0 : index;
				$(this).html("<a href='"+ self.adsData[adsIndex].url +"'><img src='"+ SITE_URL +"assets/ads/"+ self.adsData[adsIndex].id +".jpg'></a>");
			} else {
				adsIndex = index;
			}
		});
	},
	inactivityTimeout: null,
	get: function()
	{
		var self = this;

		if(this.busy) return;

		clearTimeout(this.inactivityTimeout);
		this.inactivityTimeout = setTimeout(function() {
			self.reset();
		}, 120 * 60000);

		this.busy = true;

		App.showPreLoader();

		
		Svc.get(SITE_URL + "contentMobile/feed?page=" + this.page, function(data) {
			self.getResult(data);
		});
	},
	getResult: function(rs)
	{
		App.hidePreLoader();

		this.pages	= rs.total;
		if(this.pages > 1 && this.pages != this.page)
			$(".feed .btn-more").show().attr("disabled", null);
		else
			$(".feed .btn-more").hide();

		var arr		= rs.data;
		var it, img, data;
		for(var i = 0; i < arr.length; i++)
		{ 
			data = arr[i]; 

			it = this.model.clone().show();
			it.attr("data-id", data.id); 
			it.attr("data-share-title", data.title); 
			it.attr("data-share-thumb", UPLOAD_URL + "contents/" + data.filepath + "-4.jpg"); 
			it.attr("data-share-link", BASE_URL + 'content/' + data.id);
			it.attr("data-share-owner", data.owner_fname);
			it.find("header > a").attr("href", "user.html?uid=" + data.owner_id);
			it.find("header span.item-feed-name").html(data.owner_fname);
			it.find("header .dt").html(data.dt);
			it.find("header img").attr("src", UPLOAD_URL + "profile/a" + (data.owner_id % 20) + "/" + data.owner_id + "-1.jpg");
			it.find("article > a > img").attr("src", UPLOAD_URL + "contents/" + data.filepath + "-4.jpg");
			//it.find("article > a").attr("href", APP_URL + "content.html?id=" + data.id + "&in-set=stream");
			it.find("article .ico-views").parent().append(formatNum(data.n_vis));
			it.find("article .ico-comments").parent().append(data.n_comments);
			it.find("article .ico-shares").parent().find("i").html(data.n_blists);
			it.find("article .ico-likes").parent().find("i").html(formatNum(data.n_likes));
			it.find(".description").html(App.parseTag(data.title));
			if(parseInt(data.shared) > 0)
			{
				it.find(".sharer").html("Compartilhado por <a href='user.html?uid="+ data.sharer_id +"'>"+ data.sharer +"</a>")
			}

			it.find("article .btn-like").attr("data-id", data.id).attr("data-value", data.liked).attr("data-count", data.n_likes).attr("data-status", data.liked).click(function() {
				App.like($(this).attr("data-id"), $(this).attr("data-value"));
			});
			it.find("header .btn-plus").attr("data-id", data.id).click(function() {
				App.plusContent($(this).attr("data-id"));  
			});
			it.find("article .btn-comments").attr("data-id", data.id).click(function() {
				App.load("comments.html?page=comments&id=" + $(this).attr("data-id"));
			});
			// it.find("article .btn-share").attr("data-id", data.id).click(function() {
			it.find("article .btn-share")
				.attr("data-id", data.id)
				.attr("data-share-title", data.title)
				.attr("data-share-owner", data.owner_fname)
				.attr("data-share-thumb", UPLOAD_URL + "contents/" + data.filepath + "-4.jpg")
				.attr("data-share-link", BASE_URL + 'content/' + data.id)
				.click(function(e) {
					e.preventDefault;
					var id = $(this).attr("data-id");
					var titleShare = $(this).attr("data-share-title");
					var thumbShare = $(this).attr("data-share-thumb");
					var thumbOwner = $(this).attr("data-share-owner");
					var linkShare = $(this).attr("data-share-link");
					App.shareContent(id, titleShare, thumbShare, linkShare, thumbOwner);
			});

			it.on('doubletap', function() {
				$(this).find(".btn-like").trigger("click");
			});

			$(".feed .feed-container").append(it);
		}

		this.busy = false;

		this.buildAds();
	},
	loadMore: function()
	{
		this.page = Math.min(this.pages, this.page + 1);
		$(".feed .btn-more").attr("disabled", "disabled");

		if(this.searchBy)
		{
			this.search();
		} else {
			this.get();
		}
	},
	search: function()
	{
		var self = this;

		$(".feed .search-input").blur();

		App.showPreLoader();

		$(".feed .btn-more").attr("disabled", "disabled");

		if(this.page <= 1)
			$(".feed .feed-container").html("");

		this.searchBy = $(".feed .btn-group li:first-child").hasClass("selected") ? "content" : "user";

		var str = $(".feed .search-input").val().split("/").join("");

		Svc.get(SITE_URL + "contentMobile/discovery?type=" + this.searchBy + "&q=" + str + "&page=" + this.page, function(data) {
			self.searchResult(data);
		});
	},
	searchResult: function(rs)
	{
		App.hidePreLoader();

		this.pages = this.searchBy == "content" ? Math.ceil(rs.total / 70) : Math.ceil(rs.total / 50);

		var self = this;
		var data = rs.data;
		var img, it;

		

		((this.page +1) < this.pages) ? $(".btn-more").show().attr("disabled", null) : $(".btn-more").hide();

		for(var i = 0; i < data.length; i++)
		{
			if(this.searchBy == "content")
			{
				img = UPLOAD_URL + "contents/" + data[i].filepath + "-1.jpg";
				it = $("<a class='c-thumb'><div><img src='"+ img+"'></div></a>");
				it.attr("href", "content.html?id=" + data[i].id);
			} else {
				it = this.userModel.clone().show();
				img = UPLOAD_URL + "profile/a" + (data[i].id % 20) + "/" + data[i].id + "-2.jpg";
				it.find("a").attr("href", "user.html?uid=" + data[i].id);
				
				it.find("> a").css({'background-image': 'url(' + img + ')',
								'background-size': '145px auto'});
				
				it.find(".fullname").html(data[i].fullname);
				it.find(".ocup").html(data[i].occupation);
				it.find(".followers").html("Seguido por " + data[i].n_followers);
				if( data[i].n_followers < 1) it.find(".followers").hide();

				it.find(".following").html("Seguindo " + data[i].n_following);
				if( data[i].n_following < 1) it.find(".following").hide();

				it.find("button").attr("data-id", data[i].id).attr("data-value", data[i].following).click(function() {
					App.follow($(this).attr("data-id"), $(this).attr("data-value"), function(data) {
						//self.followResult(data);
					});
				});
			}

			$(".feed .feed-container").append(it);
		}

		if(data.length < 1)
			$(".feed .feed-container").html("Nenhum resultado");
	}
}