Message = {
	userId: 0,
	cursorId: 0,
	model: null,
	userfname: null,
	initialized: false,
	init: function()
	{
		var self = this;

		if(this.initialized) return;
		this.initialized = true;

		this.userId		= this.cursorId = 0;
		this.userName	= null;

		this.userId		= App.getParam("userId");
		this.userfname	= App.getParam("userfname");
		
		App.setTitle("Mensagens");

		this.model = $(".comment").clone();
		
		$(".message .btn-more").click(function() {
			self.getMessages();
		}).hide();

		$(".message .btn-post").click(function() {
			self.postMessage();
		});

		this.getMessages();
	},
	getMessages: function()
	{
		var self = this;
		Svc.get(SITE_URL + "messages/getMessages/" + this.userId + "?c=" + this.cursorId, function(data) {
			self.getMessagesResult(data);
		});

		App.getNotifications();
		App.getActivities();
	},
	getMessagesResult: function(data)
	{
		data.length < 4 ? $(".message .btn-more").hide() : $(".btn-more").show();

		for(var i = 0; i < data.length; i++)
			this.appendItem(data[i]);

		var o = data.length > 0 ? data[0] : 0;
		if(o) this.cursorId = -o.id;


		$(".comment-list").removeClass("bg-loading");
	},
	appendItem: function(vo, prepend)
	{
		var li = this.model.clone();
		li.find("article").html(vo.message);
		li.find(".dt").html(vo.dt);


		li.find(".fname").html(vo.sender_id == App.userId ? "Eu" : this.userfname);
		li.find("img").attr("src", UPLOAD_URL + "profile/a" + ( vo.sender_id % 20) + "/" + vo.sender_id + "-2.jpg");

		if(this.cursorId && !prepend)
			$(".comment-list").append(li);
		else
			$(".comment-list").prepend(li);
	},
	postMessage: function()
	{
		$(".btn-post").attr("disabled", "disabled");

		var self = this;
		var data = {
			msg: $(".input-txt-comment").val(),
			to: self.userId
		}
		Svc.post(SITE_URL + "messages/post", data, function(rs) {
			self.postMessageResult(rs, data);

			$(".btn-post").attr("disabled", null);
		});
	},
	postMessageResult: function(rs, data)
	{
		if(rs.id)
		{
			$(".input-txt-comment").val("");

			var vo = {id: rs.id, sender_id: App.userId, message: data.msg};
			this.appendItem(vo, true);
		}
	}
}