Search = {
	model: null,
	userModel: null,
	searchBy: null,
	page: 1,
	pages: 0,
	initialized: false,
	adsData: null,
	adsInterval: 5,
	busy: false,
	ready: false,
	filter: null,
	searchterm: false,
	init: function()
	{
		App.setTitle("Busca");
		console.log("INIT");
		
		if(this.initialized)
		{
			this.reset();
			return;
		}

		this.model = $(".search .feed-item");
		this.model.remove();

		this.userModel = $(".search .row-user");
		this.userModel.remove();

		this.searchterm = App.getParam("searchterm");

		console.log(this.searchterm);


		this.ready = true;

		this.getAds();

		this.reset();

		this.initialized = true;
		//this.get();
		if(this.searchterm != undefined && this.searchterm != false && this.searchterm != ''){
			$(".search .search-input").val(this.searchterm);
			$(".search .btn-group li:first-child").addClass("selected");
			$(".search .search-form").trigger('submit');
			// this.search();
		}

	},
	bindEvents: function()
	{
		if(this.initialized) return;

		var self = this;

		$(".search .search-form .clean-bt").click(function() {
			$(this).parent().find(".search-input").val("");
		});

		$(".search .search-form .search-input").focus(function() {
			$(this).parent().find(".clean-bt").show();
		}).blur(function() {
			if(!$(this).val())
				$(this).parent().find(".clean-bt").hide();
		});

		$(".search .btn-more").hide().click(function() {
			self.loadMore();
		});

		$(".search .search-form").submit(function(e) {
			e.preventDefault();
			self.page	= 1;
			self.pages	= 1;
			self.search();
		});

		//search
		$(".search .btn-group li").click(function() {
			$(".search .btn-group li").removeClass("selected");
			$(this).addClass("selected");
			self.page	= 1;
			self.pages	= 1;
			self.search();
			App.setTitle("Busca");
		});

		$(".search .filters .btn-top-users").click(function() {
			self.reset();
			$(".search .btn-group li").removeClass("selected");
			$(".search .btn-group li:last-child").addClass("selected");
			self.filter = "topUsers";
			self.getTopUsers();
			self.hideSearch();
			App.setTitle("Mais Seguidos");
		});

		$(".search .filters .btn-top-likes").click(function() {
			self.reset();
			$(".search .btn-group li").removeClass("selected");
			$(".search .btn-group li:first-child").addClass("selected");
			self.filter = "topLikes";
			self.get();
			self.hideSearch();
			App.setTitle("Mais Curtidos");
		});

		$(".search .filters .btn-editors").click(function() {
			self.reset();
			$(".search .btn-group li").removeClass("selected");
			$(".search .btn-group li:first-child").addClass("selected");
			self.filter = "editors";
			self.get();
			self.hideSearch();
			App.setTitle("Escolhas do Editor");
		});
		this.adjustLayout();
	},
	hideSearch: function(flag)
	{
		if(flag === false)
		{
			$(".search .search-form").show();
			$(".search .btn-group").show();
		} else {
			$(".search .search-form").hide();
			$(".search .btn-group").hide();
		}
	},
	reset: function()
	{
		if(!this.ready) return;

		App.setTitle("Busca");

		this.hideSearch(false);

		$(".search .feed-container").html("");

		$(".search .btn-more").hide();

		$(".filters").show();

		this.searchBy = null;
		this.page = 1;
		this.pages = 0;
		this.filter = null;

		this.bindEvents();

		//this.get();
	},
	getAds: function()
	{
		var self = this;
		Svc.get(SITE_URL + "ads/mobile", function(data) {
			self.getAdsResult(data);
		});
	},
	getAdsResult: function(data)
	{
		this.adsData = App.adsData = data;

		this.buildAds();
	},
	buildAds: function()
	{
		if(!this.adsData) return;
		var self = this;

		var i = 0;
		$(".search .feed-container").children().each(function() {
			if($(this).hasClass("feed-item"))
			{
				i++;
				if(i == self.adsInterval && !$(this).next().hasClass("ads"))
				{
					var ads = $("<div class='ads'></div>");
					$(this).after(ads);
					i = 0;
				}
			} else {
				i = 0;
			}
		});

		var adsIndex = -1;
		var adsLen = this.adsData.length;
		$(".search .feed-container .ads").each(function() {
			var index = parseInt($(this).attr("index"));
			if(isNaN(index))
			{
				index		= adsIndex + 1;
				adsIndex	= index >= adsLen ? 0 : index;
				$(this).html("<a href='"+ self.adsData[adsIndex].url +"'><img src='"+ SITE_URL +"assets/ads/"+ self.adsData[adsIndex].id +".jpg'></a>");
			} else {
				adsIndex = index;
			}
		});
	},
	adjustLayout: function(){
		var widthAvaliable = $('.ui-page').width();
		var paddingTotal = parseInt($('.ui-content').css('padding-left'));
		var boxItem = ((widthAvaliable-(paddingTotal *2))/3);
		var realAvaliableBox = (boxItem -2);
		console.log('paddingTotal '+paddingTotal);
		console.log('widthAvaliable '+widthAvaliable);
		console.log('boxItem '+boxItem);
		console.log('realAvaliableBox '+realAvaliableBox);

		$('.c-thumb').css('width', realAvaliableBox);
		$('.c-thumb > div > img').width(realAvaliableBox);
		$('.c-thumb > div > img').height(realAvaliableBox);
	},
	get: function()
	{
		var self = this;

		if(this.busy) return;

		this.busy = true;

		App.showPreLoader();

		$(".filters").hide();

		var url = SITE_URL + "contentMobile/feed";

		if(this.filter == "topLikes")
			url = SITE_URL + "contentMobile/topLikes";
		else if(this.filter == "editors")
			url = SITE_URL + "contentMobile/editors";
		
		Svc.get(url + "?page=" + this.page, function(data) {
			self.getResult(data);
		});
	},
	getResult: function(rs)
	{
		App.hidePreLoader();

		this.pages	= rs.total;
		if(this.pages > 1 && this.pages != this.page)
			$(".search .btn-more").show().attr("disabled", null);
		else
			$(".search .btn-more").hide();

		var arr		= rs.data;
		var it, img, data;
		for(var i = 0; i < arr.length; i++)
		{
			data = arr[i];

			it = this.model.clone().show();
			it.attr("data-id", data.id);
			it.find("header > a").attr("href", "user.html?uid=" + data.owner_id);
			it.find("header span.search-item-username").html(data.owner_fname);
			it.find("header .dt").html(data.dt);
			it.find("header img").attr("src", UPLOAD_URL + "profile/a" + (data.owner_id % 20) + "/" + data.owner_id + "-1.jpg");
			it.find("article > a > img").attr("src", UPLOAD_URL + "contents/" + data.filepath + "-4.jpg");
			//it.find("article > a").attr("href", APP_URL + "content.html?id=" + data.id + "&in-set=stream");
			it.find("article .ico-views").parent().append(data.n_vis);
			it.find("article .ico-comments").parent().append(data.n_comments);
			it.find("article .ico-shares").parent().find("i").html(data.n_blists);
			it.find("article .ico-likes").parent().find("i").html(data.n_likes);
			it.find(".description").html(data.title);

			it.find("article .btn-like").attr("data-id", data.id).attr("data-value", data.liked).attr("data-count", data.n_likes).attr("data-status", data.liked).click(function() {
				App.like($(this).attr("data-id"), $(this).attr("data-value"));
			});
			it.find("header .btn-plus").attr("data-id", data.id).click(function() {
				App.plusContent($(this).attr("data-id"));  
			});
			it.find("article .btn-comments").attr("data-id", data.id).click(function() {
				App.load("comments.html?page=comments&id=" + $(this).attr("data-id"));
			});
			// it.find("article .btn-share").attr("data-id", data.id).click(function() {
			// 	var id = $(this).attr("data-id");
			// 	App.shareContent(id, $("[data-id="+ id +"] .description").html(), $("[data-id="+ id +"] header img").attr("src"));
				//App.load("share.html?uid=" + $(this).attr("data-id"));
				it.find("article .btn-share")
				.attr("data-id", data.id)
				.attr("data-share-title", data.title)
				.attr("data-share-owner", data.owner_fname)
				.attr("data-share-thumb", UPLOAD_URL + "contents/" + data.filepath + "-4.jpg")
				.attr("data-share-link", BASE_URL + 'content/' + data.id)
				.click(function(e) {
					e.preventDefault;
					var id = $(this).attr("data-id");
					var titleShare = $(this).attr("data-share-title");
					var thumbShare = $(this).attr("data-share-thumb");
					var thumbOwner = $(this).attr("data-share-owner");
					var linkShare = $(this).attr("data-share-link");
					App.shareContent(id, titleShare, thumbShare, linkShare, thumbOwner);			});

				it.on('doubletap', function() {
					$(this).find(".btn-like").trigger("click");
				});

				$(".search .feed-container").append(it);
			}

			this.busy = false;

			this.buildAds();
		},
		loadMore: function()
		{
			this.page = Math.min(this.pages, this.page + 1);
			$(".search .btn-more").attr("disabled", "disabled");

			if(this.searchBy)
			{
				this.search();
			} else {
				this.get();
			}
		},
		search: function()
		{
			var self = this;

			$(".search .search-input").blur();

			App.showPreLoader();

			$(".filters").hide();

			$(".search .btn-more").attr("disabled", "disabled");

			if(this.page <= 1)
				$(".search .feed-container").html("");

			this.searchBy = $(".search .btn-group li:first-child").hasClass("selected") ? "content" : "user";

			var str = $(".search .search-input").val().split("/").join("");

			Svc.get(SITE_URL + "contentMobile/discovery?type=" + this.searchBy + "&q=" + str + "&page=" + this.page, function(data) {
				self.searchResult(data);
			});
		},
		getTopUsers: function()
		{
			var self = this;

			App.showPreLoader();

			$(".filters").hide();

			this.searchBy = "users";

			if(this.page <= 1)
				$(".search .feed-container").html("");

			Svc.get(SITE_URL + "contentMobile/topUsers?page=" + this.page, function(data) {
				self.searchResult(data);
			});
		},
		searchResult: function(rs)
		{
			App.hidePreLoader();

			this.pages = this.searchBy == "content" ? Math.ceil(rs.total / 40) : Math.ceil(rs.total / 50);

			var self = this;
			var data = rs.data;
			var img, it;

			((this.page +1) < this.pages) ? $(".btn-more").show().attr("disabled", null) : $(".btn-more").hide();

			for(var i = 0; i < data.length; i++)
			{
				if(this.searchBy == "content")
				{
					img = UPLOAD_URL + "contents/" + data[i].filepath + "-1.jpg";
					it = $("<a class='c-thumb'><div><img src='"+ img+"'></div></a>");
					it.attr("href", "content.html?id=" + data[i].id);
				} else {
					it = this.userModel.clone().show();
					img = UPLOAD_URL + "profile/a" + (data[i].id % 20) + "/" + data[i].id + "-2.jpg";
					it.find("a").attr("href", "user.html?uid=" + data[i].id);
					it.find("> a").css({'background-image': "url(" + img + ")", 'background-size':'145px auto'});
					it.find(".fullname").html(data[i].fullname);
					it.find(".ocup").html(data[i].occupation);
					it.find(".followers").html("Seguido por " + data[i].n_followers);
					if( data[i].n_followers < 1) it.find(".followers").hide();

					it.find(".following").html("Seguindo " + data[i].n_following);
					if( data[i].n_following < 1) it.find(".following").hide();

					it.find("button").attr("data-id", data[i].id).attr("data-value", data[i].following).click(function() {
						App.follow($(this).attr("data-id"), $(this).attr("data-value"), function(data) {
						//self.followResult(data);
					});
					});
				}

				$(".search .feed-container").append(it);
			}

			if(data.length < 1)
				$(".search .feed-container").html("Nenhum resultado");
		}
	}