Tour = {
	init: function()
	{
		var self = this;

		App.fixHeight();

		$(".tour [data-role='content']").width($(window).width());

		$(".tour .container").width($(window).width() * $(".tour .container").children().length);
		$(".tour .container").children().css("width", $(window).width());

		$(".tour .container > div").each(function() {
			$(".tour .nav > div").append("<div class='link'><span></span></div>");
		});

		$(".tour .link").click(function() {
			self.position = $(this).index() - 1;
			self.move(1);
		});
		$(".tour .link").eq(0).addClass("link-selected");

		$('.tour .container').bind("swipeleft", function(){
			self.move(1);
		});
		$('.tour .container').bind("swiperight", function(){
			self.move(-1);
		});

		$(".tour .next").click(function() {
			if(self.position >= ($(".tour .container").children().length - 1))
				self.skip();
			else
				self.move(1);
		});

		$(".tour .skip").click(function() {
			self.skip();
		});

	},
	skip: function()
	{
		App.userId > 0 ? App.load("feed.html") : App.openLogin();
	},
	position: 0,
	move: function(p)
	{
		var count = $(".tour .container").children().length - 1;
		this.position = Math.max(0, Math.min(this.position + p, count));
		var x = - ($(window).width() * this.position);
		$(".tour .container").animate({marginLeft: x}, 250);

		$(".tour .nav .link").removeClass("link-selected");
		$(".tour .nav .link").eq(this.position).addClass("link-selected");
	}
}