User = {
	id: 0,
	model: null,
	userModel: null,
	page: 1,
	pages: 0,
	section: null,
	adsInterval: 5,
	initialized: false,
	currentUserData: null,
	init: function()
	{

		$('.user-info').width(($('.ui-page').width() - parseInt($('.ui-content').css('padding-right')) - parseInt($('.ui-content').css('padding-left'))));

		if(this.initialized)
		{
			return;
		}

		var self = this;

		this.id = App.getParam("uid");
		if(!this.id && App.userId)
			this.id = App.userId;

		this.section = App.getParam("section");
		if(!this.section)
			this.section = "";

		if(this.id == App.userId && this.id)
			$(".nav-menu li[data-s='user']").addClass("selected");
		
		this.updateTitle();

		this.model = $(".user .feed-item");
		this.model.remove();

		this.userModel = $(".user .row-user");
		this.userModel.remove();
		
		$(".user .btn-more").hide().click(function() {
			self.loadMore();
		});

		$(".user .btn-follow").hide();
		$(".user .btn-msg").hide();


		if(this.section == "followers" || this.section == "following")
			this.page = 0;

		this.getUserInfo();

		this.initialized = true;
	},
	buildAds: function()
	{
		if(!App.adsData) return;
		var self = this;

		var i = 0;
		$(".user .feed-container").children().each(function() {
			if($(this).hasClass("feed-item"))
			{
				i++;
				if(i == self.adsInterval && !$(this).next().hasClass("ads"))
				{
					var ads = $("<div class='ads'></div>");
					$(this).after(ads);
					i = 0;
				}
			} else {
				i = 0;
			}
		});

		var adsIndex	= -1;
		var adsLen		= App.adsData.length;
		$(".user .feed-container .ads").each(function() {
			var index = parseInt($(this).attr("index"));
			if(isNaN(index))
			{
				index		= adsIndex + 1;
				adsIndex	= index >= adsLen ? 0 : index;
				$(this).html("<a href='"+ App.adsData[adsIndex].url +"'><img src='"+ SITE_URL +"assets/ads/"+ App.adsData[adsIndex].id +".jpg'></a>");
			} else {
				adsIndex = index;
			}
		});
	},
	getUserInfo: function()
	{
		var self = this;
		Svc.get(SITE_URL + this.id + "/about?json=1", function(data) {
			self.getUserInfoResult(data);
		});
	},
	getContents: function()
	{
		App.showPreLoader();

		var self = this;
		if(this.section == "likes")
		{
			Svc.get(SITE_URL + "usersMobile/likes/"+ this.id + "?page=" + this.page, function(data) {
				self.getContentsResult(data);
			});

		} else if(this.section == "following" || this.section == "followers")
		{
			Svc.get(SITE_URL + "usersMobile/"+ this.section +"/"+ this.id + "?page=" + this.page, function(data) {
				self.getFollowsResult(data);
			});
		} else if(this.section == "") {
			Svc.get(SITE_URL + "content/getContents/uid/"+ this.id + "/m/1/?page=" + this.page, function(data) {
				self.getContentsResult(data);
			});
		} else if(this.section == "profile") {
			Svc.get(SITE_URL + this.id + "/about?json=1", function(data) {
				self.getProfileResult(data);
			});
		}
	},
	getUserInfoResult: function(data)
	{
		var self = this;
		App.setTitle(data.fullname);

		this.currentUserData = data;

		$(".user-info").css("visibility", "visible");
		//$(".user-info .thumb-profile-container img").attr("src", data.avatar);
		$(".user-info .thumb-profile-container").css("background-image", "url(" + data.avatar + ")").css('background-size', '180px auto');
		$(".user-info .followers").html("Seguido por " + data.n_followers).click(function() {
			self.section = "followers";
			self.page = 0;
			self.updateTitle();
			$(".user .feed-container").html("");
			self.getContents();
		});
		$(".user-info .following").html("Segue " + data.n_following).click(function() {
			self.section = "following";
			self.page = 0;
			self.updateTitle();
			$(".user .feed-container").html("");
			self.getContents();
		});
		$(".user-info .about-me").html(data.about_me);
		if(data.about_me)
			$(".user-info").css("height", "auto");


		if(data.n_following < 1)
			$(".user-info .following").hide();

		$(".user-info .fname").html(data.fullname);

		if(data.occupation && data.occupation != "0")
			$(".user-info .occupation").html(data.occupation + " " + (data.occupation_area ? data.occupation_area : ""));

		$(".user-info").find(".btn-follow").attr("data-id", data.id).attr("data-count", data.n_followers).attr("data-value", data.following).click(function() {
			App.follow($(this).attr("data-id"), $(this).attr("data-value"), function(data) {
				var btn = $(".user-info .btn-follow");
				var c = parseInt(btn.attr("data-count"));
				c = btn.attr("data-value") == "1" ?   c + 1 : c - 1;
				$(".followers").html("Seguido por " + c);
				btn.attr("data-count", c);
			});
		});
		$(".user-info").find(".btn-msg").click(function() {
			App.load("message.html?userId="+ data.id +"&userfname=" + data.fullname);
		});

		$(".user-info").find(".btn-plus-user").click(function() {
			App.plusUser(data.id);
		});


		if(data.id != App.userId && App.userId)
			$(".user-info").find(".btn-msg").show();

		$(".user .btn-vis").append(formatNum(data.ct_vis));
		$(".user .btn-like").append(formatNum(data.ct_likes));
		$(".user .btn-share").append(data.ct_blists);
		if(this.id != App.userId)
			$(".user .btn-follow").show();

		this.getContents();
	},
	getProfileResult: function(rs)
	{
		var ul = $("<ul class='profile list nopad'></ul>");
		$(".user .canvas").append(ul);

		ul.append("<li><b>Nome</b> " + rs.fullname + "</li>");
		if(rs.occupation)
			ul.append("<li><b>Ocupao</b> " + rs.occupation + "</li>");
		if(rs.occupation_area)
			ul.append("<li><b>Nicho</b> " + rs.occupation_area + "</li>");
		if(rs.city)
			ul.append("<li><b>Localidade</b> " + rs.city + "</li>");
		if(rs.interests)
			ul.append("<li><b>Interesses</b> " + rs.interests + "</li>");
		if(rs.about_me)
			ul.append("<li><b>Sobre mim</b> " + rs.about_me + "</li>");
		if(rs.website)
			ul.append("<li><b>Website</b> " + rs.website + "</li>");
		

		App.hidePreLoader();
	},
	getContentsResult: function(rs)
	{
		this.pages	= rs.total;
		if(this.pages > 1 && this.pages != this.page)
			$(".user .btn-more").show().attr("disabled", null);
		else
			$(".user .btn-more").hide();


		var arr		= rs.data;
		var it, img, data;
		for(var i = 0; i < arr.length; i++)
		{
			data = arr[i];

			it = this.model.clone().show();
			it.find("header > a").attr("href", "user.html?uid=" + data.owner_id);
			it.find("header span.feed-item-username").html(data.owner_fname);
			it.find("header .dt").html(data.dt);
			it.find("header img").attr("src", UPLOAD_URL + "profile/a" + (data.owner_id % 20) + "/" + data.owner_id + "-1.jpg");
			it.find("article > a > img").attr("src", UPLOAD_URL + "contents/" + data.filepath + "-4.jpg");
			//it.find("article > a").attr("href", "content.html?id=" + data.id + "&in-set=stream");
			it.find("article .ico-views").parent().append(formatNum(data.n_vis));
			it.find("article .ico-comments").parent().append(data.n_comments);
			it.find("article .ico-shares").parent().append(data.n_blists);
			it.find("article .ico-likes").parent().find("i").html(formatNum(data.n_likes));
			it.find(".description").html(data.title);

			it.find("article .btn-like").attr("data-id", data.id).attr("data-value", data.liked).attr("data-count", data.n_likes).attr("data-status", data.liked).click(function() {
				App.like($(this).attr("data-id"), $(this).attr("data-value"));
			});
			it.find("article .btn-comments").attr("data-id", data.id).click(function() {
				App.load("comments.html?page=comments&id=" + $(this).attr("data-id"));
			});
			it.find("header .btn-plus").attr("data-id", data.id).click(function() {
				App.plusContent($(this).attr("data-id"));  
			});
			// it.find("article .btn-share").attr("data-id", data.id).click(function() {
			// 	App.shareContent($(this).attr("data-id"));
				//App.load("share.html?uid=" + $(this).attr("data-id"));
			it.find("article .btn-share")
				.attr("data-id", data.id)
				.attr("data-share-title", data.title)
				.attr("data-share-owner", data.owner_fname)
				.attr("data-share-thumb", UPLOAD_URL + "contents/" + data.filepath + "-4.jpg")
				.attr("data-share-link", BASE_URL + 'content/' + data.id)
				.click(function(e) {
					e.preventDefault;
					var id = $(this).attr("data-id");
					var titleShare = $(this).attr("data-share-title");
					var thumbShare = $(this).attr("data-share-thumb");
					var thumbOwner = $(this).attr("data-share-owner");
					var linkShare = $(this).attr("data-share-link");
					App.shareContent(id, titleShare, thumbShare, linkShare, thumbOwner);
			});

			it.on('doubletap', function() {
				$(this).find(".btn-like").trigger("click");
			});

			$(".user .feed-container").append(it);
		}
		
		App.hidePreLoader();

		if(parseInt(this.currentUserData.usertype) != 3)
			this.buildAds();

	},
	getFollowsResult: function(data)
	{
		App.hidePreLoader();

		this.pages	= this.section == "followers" ? this.currentUserData.n_followers : this.currentUserData.n_following;
		this.pages	= Math.ceil(this.pages / 20);

		if(this.pages > 1 && this.pages != this.page)
			$(".user .btn-more").show().attr("disabled", null);
		else
			$(".user .btn-more").hide();

		var self = this;
		var img, it;
		console.log(data);
		for(var i = 0; i < data.length; i++)
		{
			it = this.userModel.clone().show();
			img = UPLOAD_URL + "profile/a" + (data[i].id % 20) + "/" + data[i].id + "-2.jpg";
			it.find("a").attr("href", "user.html?uid=" + data[i].id);
			it.find("> a").css("background-image", "url(" + img + ")").css('background-size', '180px auto');
			it.find(".fullname").html(data[i].fullname);
			//it.find(".ocup").html(data[i].occupation);
			it.find(".followers").html("Seguido por " + data[i].n_followers);
			if( data[i].n_followers < 1) it.find(".followers").hide();

			it.find(".following").html("Seguindo " + data[i].n_following);
			if( data[i].n_following < 1) it.find(".following").hide();

			it.find("button").attr("data-id", data[i].id).attr("data-value", data[i].following).click(function() {
				App.follow($(this).attr("data-id"), $(this).attr("data-value"), function(data) {
					//self.followResult(data);
				});
			});

			$(".user .feed-container").append(it).css("margin", 0);
		}
	},
	loadMore: function()
	{
		this.page = Math.min(this.pages, this.page + 1);
		$(".user .btn-more").attr("disabled", "disabled");
		this.getContents();
	},
	updateTitle: function()
	{
		if(!this.section)
			$(".btn-section").html("Posts");
		else if(this.section == "likes")
			$(".btn-section").html("Likes");
		else if(this.section == "following")
			$(".btn-section").html("Seguindo");
		else if(this.section == "followers")
			$(".btn-section").html("Seguidores");
		else if(this.section == "profile")
			$(".btn-section").html("Perfil");
	}
}