YMag = {
	model: null,
	page: 1,
	pages: 0,
	id: 0,
	initialized: false,
	ready: false,
	adsInterval: 3,
	init: function()
	{


		this.id = Math.max(0, App.getParam("edition"));

		if(this.initialized)
		{
			this.reset();
			return;
		}
		this.initialized = true;

		this.model = $(".ymag .feed-item");
		this.model.remove();

		
		//this.getMags();

		this.getPosts();

		App.setTitle("YMag");
	},
	bindEvents: function()
	{
		var self = this;

		$(".ymag .btn-more").hide().click(function() {
			self.loadMore();
		});
	},
	reset: function()
	{
		this.page = 1;
		this.pages = 0;

		$(".ymag .mags").html("<option>Selecione..</option>");
		$(".ymag .mag-container").html("");

		this.getMags();

		this.getPosts();
	},
	getMags: function()
	{
		var self = this;
		Svc.get(SITE_URL + "ymag/getEditions", function(data) {
			self.getMagsResult(data);
		});
	},
	getMagsResult: function(data)
	{
		for(var i = 0; i < data.length; i++)
		{
			var vo = data[i];
			var opt = $("<option></option>");
			opt.attr("value",vo.id);
			opt.html(vo.title);

			if(vo.id == this.id)
				opt.attr("selected", "selected");

			$(".ymag .mags").append(opt);
		}
		$(".ymag .mags").change(function() {
		
			//if($(this).val()) location.href = "?s=ymag&edition=" + $(this).val();
			if($(this).val()) App.load("ymag.html?edition=" + $(this).val());
		});

		
	},
	getPosts: function()
	{
		App.showPreLoader();

		var self = this;
		//Svc.get(SITE_URL + "ymag/getPosts/"+ this.id +"/?page=" + this.page, function(data) {
		Svc.get(SITE_URL + "ymag/getAllPosts", function(data) {
			self.getPostsResult(data);
		});
	},
	getPostsResult: function(rs)
	{
		this.pages	= 1;//rs.total;
		if(this.pages > 1 && this.pages != this.page)
			$(".ymag .btn-more").show().attr("disabled", null);
		else
			$(".ymag .btn-more").hide();

		var arr		= rs;
		var it, img, data, url;

		for(var i = 0; i < arr.length; i++)
		{
			data = arr[i];
			
			url = "ymag-post.html?edition=" + data.magazine_id + "&uid=" + data.id;

			it = this.model.clone().show();
			it.find("header > a").attr("href", url);
			it.find("header h2").html(data.title);
	
			it.find("article > a > img").attr("src", UPLOAD_URL + "magazines/posts/" + data.id + "-2.jpg");
			it.find("article > a").attr("href", url);


			$(".ymag .mag-container").append(it);
			
		}
		$(".ymag .mag-container").removeClass("bg-loading");

		this.buildAds();

		App.hidePreLoader();

	},
	loadMore: function()
	{
		this.page = Math.min(this.pages, this.page + 1);
		$(".ymag .btn-more").attr("disabled", "disabled");
		this.getPosts();
	},
	buildAds: function()
	{
		if(!App.adsData) return;
		var self = this;

		var i = 0;
		$(".ymag .mag-container").children().each(function() {
			if($(this).hasClass("feed-item"))
			{
				i++;
				if(i == self.adsInterval && !$(this).next().hasClass("ads"))
				{
					var ads = $("<div class='ads'></div>");
					$(this).after(ads);
					i = 0;
				}
			} else {
				i = 0;
			}
		});

		var adsIndex	= -1;
		var adsLen		= App.adsData.length;
		$(".ymag .mag-container .ads").each(function() {
			var index = parseInt($(this).attr("index"));
			if(isNaN(index))
			{
				index		= adsIndex + 1;
				adsIndex	= index >= adsLen ? 0 : index;
				$(this).html("<a href='"+ App.adsData[adsIndex].url +"'><img src='"+ SITE_URL +"assets/ads/"+ App.adsData[adsIndex].id +".jpg'></a>");
			} else {
				adsIndex = index;
			}
		});
	},
}