// alert('app present');

function formatNum(n)
{
	n = parseInt(n);
	n = isNaN(n) ? 0 : n;
	return n > 999 ? parseFloat(n / 1000).toFixed(3) : n;
}

App = {
	userId: 0,
	username: "",
	userfname: "",
	section: null,
	total_notifications: "",
	getActivitiesInterval: null,
	pushing: 0, // 0 - not started; 1 - starting; 2 - started;
	hasToken: false,
	logged: false,
	NOT_CONNECTED_MESSAGE: "Verifique sua conexão com a Internet",
	pushNotification: false,
	init: function()
	{
		var self = this;
		if(!navigator.notification)
			navigator.notification = window;
		if(!navigator.connection)
			navigator.connection = {};
			
		if(!App.pushNotification){
			App.pushNotification = window.plugins.pushNotification;
		}
		// alert('App.pushNotification '+ App.pushNotification);
		// alert(device);
		// alert(device.platform);

		document.addEventListener("offline", function() {
			navigator.notification.alert(
				App.NOT_CONNECTED_MESSAGE,  // message
				null,						// callback
				'Não conectado',			// title
				'OK'						// buttonName
				);
		}, false);


		console.log("Token: " + window.localStorage.token);

		if(String(window.localStorage.token).length > 10)
		{
			this.hasToken = true;
			console.log("authWithToken: token: " + window.localStorage.token);
			Svc.post(SITE_URL + "login/authWithToken", {token: window.localStorage.token}, function(data) {
				console.log("authWithToken: result: " + JSON.stringify(data));
				if(data.user_id)
				{
					App.userId		= parseInt(data.user_id);
					App.userfname	= data.username;
					window.localStorage.userType = data.type;

					App.onLogin();
				}
			});
		} else if(String(window.localStorage.fbtoken).length > 10){
			this.hasToken = true;
			App.authWithFacebookToken();
		}
		try {
			FB.Event.subscribe('auth.login', function(response) {
				//navigator.notification.alert("auth.login");
				console.log("FB auth.login");
				App.authWithFacebookToken();
			});

			FB.Event.subscribe('auth.sessionChange', function(response) {
				console.log("FB auth.sessionChange : " + JSON.stringify(response));

			});
			FB.Event.subscribe('auth.statusChange', function(response) {
				console.log("FB auth.statusChange : " + JSON.stringify(response));
			});

		} catch(e) {}

		$.mobile.loadPage('plus-content.html', { showLoadMsg: false } );
		$.mobile.loadPage('report-content.html', { showLoadMsg: false } );
		$.mobile.loadPage('send-photo.html', { showLoadMsg: false } );
		$.mobile.loadPage('add-post.html', { showLoadMsg: false } );

		$( document ).bind( "pagebeforeshow", function( event, data ){
			$(".nav-menu").html(
				'<li data-s="feed"><a href="feed.html"></a></li>' +
				'<li data-s="search"><a href="search.html"></a></li>' +
				'<li data-s="upload"></li>' +
			// '<li data-s="ymag"><a href="follow.html"></a></li>' +
			'<li data-s="ymag"><a href="ymag.html"></a></li>' +
			'<li data-s="academy"><a href="academy.html"></a></li>');

			App.checkLogin();

			$("[data-role=header]").fixedtoolbar({ tapToggle: false });
			$("[data-role=footer]").fixedtoolbar({ tapToggle: false });

			// $('#sendPhoto').unbind('click');

			$("[data-s=upload]").unbind("click").on('click', function(e){
				e.preventDefault();
				navigator.notification.confirm("Selecione a origem da imagem", function(arg){ 
					App.getPictury(arg);
				}, "Enviar Foto", ["Câmera", "Galeria", "Cancelar"]);
				return false;
			});		

			// $("[data-s=upload], .getImageBrowser").unbind("change").change(function(event) {
			// 	PostFileSelect.onSelectFile(event.target.files);
			// });

if(App.userId)
	$(".page-header .n-notifications").html(App.total_notifications);


$(".page-header .back-bt").unbind("click").click(function() {
	if($.mobile.activePage.attr('id') == "edit-profile")
		history.go(-2);
	else
		history.go(-1);
});


$(".btn-menu").unbind("click").click(function() {
	if($.mobile.activePage.attr('id') == "edit-profile")
	{
		App.load("feed.html");
		return;
	}
	if($("#user-menu").hasClass("ui-page-active"))
	{
		$('[data-role=dialog]').dialog( "close" );
		return;
	}
	self.showMenu();
});

$("[data-s=feed] a[href='feed.html']").attr("href", "feed.html").click(function() {
	Feed.reset();
});

$("[data-s=search] a[href='search.html']").attr("href", "search.html").click(function() {
	Search.reset();
});


var tt = $(event.target).attr("data-title");

			// App.getNotifications();
		});



/* ios6 calc fix */
$('.nopad').css('width', '100%').css('width', '+=40px');


$(window).resize(function() {
	self.onResize();
});
self.onResize();

var execTimes = window.localStorage.execTimes > 0 ? window.localStorage.execTimes : 0;
window.localStorage.execTimes = execTimes + 1;

setTimeout(function() {
	if(execTimes < 1)
		App.load("tour.html");
	else
		App.load(App.hasToken ? "feed.html" : "login.html");

	if(navigator.splashscreen)
		navigator.splashscreen.hide();
}, 2000);

this.getMobileNotifications();
},
uploadPicture: function(mediaFile) {
	console.log(mediaFile);
    path = mediaFile;
    name = mediaFile.substr(mediaFile.lastIndexOf('/') + 1);
    
    var options = new FileUploadOptions();
    options.fileKey="file";
    options.fileName=name;
    options.mimeType="image/jpeg";

    var params = new Object();
    params.fullpath = path;
    params.name = name;

    options.params = params;
    options.chunkedMode = false;
    
    var ft = new FileTransfer();
    ft.upload( path, BASE_URL +"content/upMobilePicture",
        function(r) {
        	// console.log(r);
        	result = JSON.parse(r.response);
        	App.load("add-post.html?file=" + result.filename);
        },
        function(error) {
        	console.log('error');
        	alert('Erro');
        	console.log(error);
            //upload unsuccessful, error occured while upload. 
        },
        options
        );
},
successHandler: function(result) {
	// alert('Callback Success! Result = ' + result )
	window.localStorage.tokenPush = result;
	window.localStorage.tokenType = 'android';
},
tokenHandler: function(result) {
	    // Your iOS push server needs to know the token before it can push to this device
	    // here is where you might want to send it the token for later use.
	    // alert('device token = ' + result);
		window.localStorage.tokenPush = result;
		window.localStorage.tokenType = 'ios';
		App.registerPush();
},
errorHandler:function(error) {
	window.localStorage.tokenPush = false;
	window.localStorage.tokenType = false;
},
onNotificationAPN: function(event) {
    	if ( event.alert )
    	{
    		navigator.notification.alert(event.alert);
    	}

    	if ( event.sound )
    	{
    		var snd = new Media(event.sound);
    		snd.play();
    	}

    	if ( event.badge )
    	{
    		App.pushNotification.setApplicationIconBadgeNumber(
	    			App.successHandler, 
	    			App.errorHandler, 
	    			parseInt(event.badge)
    			);
    	}
},
registerPush: function(logout){

	if(logout){
	
		    $.post(BASE_URL + "usersMobile/tokens?debug", {
		    		tokenType: window.localStorage.tokenType,
	    			tokenPush: window.localStorage.tokenPush
	    		}, function(dataBack){
	    			if(dataBack.device_id > 0){
	    				window.localStorage.tokenDevideId = dataBack.device_id;
	    			} else {
	    				window.localStorage.tokenDevideId = false;
	    			}
	    		}, 'json');
		} else {
			$.post(BASE_URL + "usersMobile/tokens?debug", {
		    		tokenType: window.localStorage.tokenType,
	    			tokenPush: window.localStorage.tokenPush
	    		}, function(dataBack){
	    			if(dataBack.device_id > 0){
	    				window.localStorage.tokenDevideId = dataBack.device_id;
	    			} else {
	    				window.localStorage.tokenDevideId = false;
	    			}
	    		}, 'json');
		}
},

onNotificationGCM: function(e) {
    	// $("#app-status-ul").append('<li>EVENT -> RECEIVED:' + e.event + '</li>');

    	switch( e.event )
    	{
    		case 'registered':
    		if ( e.regid.length > 0 )
    		{
    			// $("#app-status-ul").append('<li>REGISTERED -> REGID:' + e.regid + "</li>");
                // Your GCM push server needs to know the regID before it can push to this device
                // here is where you might want to send it the regID for later use.
                // if('APA91bEppNvnKC4CzmJV8DGBQagaPeVSzH6B_Su2Kl2kDPsfcoAAS68DLSL5D7ICzzQQauuQD_PT0_Axoowyaxwllk_lbbshRokW2oR2p8YAicE_nJnVQRy_aiSga3QDUw4sgqLkb28hlT2fz4k-VFydLYGlOBQ')
                // console.log("regID = " + e.regid);
                // alert(e.regid);
				window.localStorage.tokenType = 'android';
            	window.localStorage.tokenPush = e.regid;
            	App.registerPush();
            } else {
            	window.localStorage.tokenPush = false;
				window.localStorage.tokenType = 'android';
				window.localStorage.tokenDevideId = false;
            }

            break;

            case 'message':
     //this notification happened while we were in the foreground.
            // you might want to play a sound to get the user's attention, throw up a dialog, etc.
            if ( e.foreground )
            {
            	// $("#app-status-ul").append('<li>--INLINE NOTIFICATION--' + '</li>');

                // if the notification contains a soundname, play it.
                var my_media = new Media("/android_asset/www/" + e.soundname);
                my_media.play();
            }
            else
            {  // otherwise we were launched because the user touched a notification in the notification tray.
            	if ( e.coldstart )
            	{
            		// $("#app-status-ul").append('<li>--COLDSTART NOTIFICATION--' + '</li>');
            	}
            	else
            	{
            		// $("#app-status-ul").append('<li>--BACKGROUND NOTIFICATION--' + '</li>');
            	}
            }

            // $("#app-status-ul").append('<li>MESSAGE -> MSG: ' + e.payload.message + '</li>');
            // $("#app-status-ul").append('<li>MESSAGE -> MSGCNT: ' + e.payload.msgcnt + '</li>');
            break;

            case 'error':
            	window.localStorage.tokenPush = false;
				window.localStorage.tokenType = 'android';
				window.localStorage.tokenDevideId = false;
            // $("#app-status-ul").append('<li>ERROR -> MSG:' + e.msg + '</li>');
            break;

            default:
            // $("#app-status-ul").append('<li>EVENT -> Unknown, an event was received and we do not know what it is</li>');
            break;
        }
},
callPushNotification: function(){

	if(App.pushing == 0){
			App.pushing = 1;
    		// alert('hey im ' + device.platform);
    	if ( device.platform == 'android' || device.platform == 'Android' )
    	{
    		
    		App.pushNotification.register(
    			App.successHandler,
    			App.errorHandler, {
    				"senderID":"987146764528",
    				"ecb":"App.onNotificationGCM"
    			});
    	}
    	else
    	{
    		// alert('No way, im ' + device.platform);
    		App.pushNotification.register(
    			App.tokenHandler,
    			App.errorHandler, {
    				"badge":"true",
    				"sound":"true",
    				"alert":"true",
    				"ecb":"App.onNotificationAPN"
    			});
    	}	

			App.pushing = 2;
	}

},

getPictury: function(keySource){
		// alert(keySource);
		if( keySource === 0 || keySource === 3 ){
			return false;
		}
		var getSourceType = 1;//navigator.camera.PictureSourceType.CAMERA;

		if( keySource === 2 ){
			getSourceType = 0;//navigator.camera.PictureSourceType.PHOTOLIBRARY;
		}
	
// alert(navigator.camera.DestinationType.NATIVE_URI);
// alert(navigator.camera.PictureSourceType.CAMERA);

    navigator.camera.getPicture(
        function(imageData){
			// App.showPreLoader();
        	// alert(imageData);
          $.ajax({
            type: "POST",
            url: SITE_URL + "content/uploadContentImageAndroid/",
            data: {baseimg : imageData},
            success: function(data){
              	// App.hidePreLoader();
              if(data.status == 1){
              	// $.mobile.changePage( APP_URL + "add-post.html?file=" + data.filename, { transition: "slide"} );
                App.load("add-post.html?file=" + data.filename);
              } else {
              	// App.hidePreLoader();
                App.notif('desculpe, tivemos um erro ao processar a imagem, tente novamente.');
              }
            },
            error: function(){
              	// App.hidePreLoader();
              App.notif('Erro de conexão, tente novamente');
            },
            dataType: 'json'
          });

        },
        function(){
          App.notif('desculpe, tivemos um erro ao acessar a imagem, tente novamente.');
        },
        {destinationType: 0,//navigator.camera.DestinationType.DATA_URL, 
    	correctOrientation: true, 
    	sourceType: getSourceType, 
    	saveToPhotoAlbum: true//,
    	//targetHeight: 600, 
	    });
 },
// getPictury: function(keySource){
// 		// alert(keySource);
// 		console.log(keySource);
// 		if(keySource === 0){
// 			return false;
// 		}
// 		var getSourceType = 1;//navigator.camera.PictureSourceType.CAMERA;
// 		if(keySource === 2){
// 			getSourceType = 0;//navigator.camera.PictureSourceType.PHOTOLIBRARY;
// 		} 
// 		// alert(navigator.camera.DestinationType.NATIVE_URI);
// 		// alert(navigator.camera.PictureSourceType.CAMERA);
// 		navigator.camera.getPicture(
// 		// navigator.device.capture.captureImage(
// 			function(imageData){
// 				console.log(imageData);
// 				App.uploadPicture(imageData);
				
//         },
//         function(){
//         	App.notif('desculpe, tivemos um erro ao acessar a imagem, tente novamente.');
//         },
//         {
//     	// allowEdit: true
//         // destinationType: 0//navigator.camera.DestinationType.DATA_URL, 
//         destinationType: 1//navigator.camera.DestinationType.FILE_URI
//         ,correctOrientation: true
//         ,sourceType: getSourceType
//         ,saveToPhotoAlbum: true
//         ,targetHeight: 600
//         ,targetWidth: 600
//         });
// },

checkLogin: function(fb)
{
	App.updateMenu($.mobile.path.parseUrl(location.href).filename.replace(/\.html/, ""));

	if(App.logged || App.userId > 0 || fb === true)
	{ 
		App.callPushNotification();

			// alert('login veio');
			//$("[data-role=footer]").find("[data-s='user']").removeClass("no-auth");
			//$("[data-role=footer]").find("[data-s='user']").find("a").attr("href", "user.html").attr("data-rel", null);
			// $("[data-role=footer]").find("[data-s='upload']").removeClass("login").find("input").show();
			// $("[data-role=footer]").find("[data-s='upload']").find("a").remove();
			$(".btn-menu").show();
		} else {
			// alert('nologin veio');
		$(".btn-menu").hide();

	}

	},
	parseTag: function(varstring){
		// replace(/#([a-zA-Z0-9]+)/, "<a href='search.html?searchterm=$1'>#$1</a>");
		// var returnstring = varstring.replace('/#beautyourself/', '<a href="search.html?searchterm=beautyourself">#beautyourself</a>');
		var returnstring = varstring.replace(/#([a-zA-Z0-9]+)/g, "<a href='search.html?searchterm=$1'>#$1</a>");
		return returnstring;
	},
	showMenu: function()
	{
		if(this.userId)
			$.mobile.changePage( "menu.html", { role: "dialog", transition: "none" } );
	},
	showPreLoader: function(text)
	{
		$.mobile.loading( 'show', {
			text: text ? text : 'Carregando...',
			textVisible: true,
			theme: 'a'
		});
	},
	hidePreLoader: function()
	{
		$.mobile.loading( 'hide');
	},
	unread_messages: 0,
	notifications: 0,
	n_notifications:0,
	getNotifications: function()
	{
		if(!this.userId) return;

		//movido p/ getActivities
		/*

		var self = this;
		Svc.get(SITE_URL + "activities/get", function(data) {
			self.n_notifications		= data.notifications;
			self.unread_messages		= data.unread_messages;
			self.total_notifications	= (data.notifications + data.unread_messages) || "";

			$(".page-header .n-notifications").html(self.total_notifications);
		});
*/
},
getActivities: function()
{
	if(!App.userId) return;
	console.log("getActivities()");

	var self = this;
	Svc.get(SITE_URL + "activities/getMobile?listActivities=1", function(data) {
			// console.log(data);
			// console.log(data.notifications);
			// console.log(data.unread_messages);
			// console.log('App.n_notifications' + App.n_notifications);
			// console.log('App.unread_messages' + App.unread_messages);
			// console.log('App.total_notifications' + App.total_notifications);

			//
			App.n_notifications		= data.notifications;
			App.unread_messages		= data.unread_messages;

			if((data.notifications + data.unread_messages) > 0){
				App.total_notifications	= (data.notifications + data.unread_messages);
			}
			else {
				App.total_notifications	= "";
			}

			$(".page-header .n-notifications").html(App.total_notifications);
			//

			try {
				window.plugin.notification.local.cancelAll();
			} catch(e) {
				// console.log("Error clearing notifications");
			}

			try {
				window.plugin.notification.badge.set(0);
			} catch (e) {
				// console.log('error set badge zero');
			}

			if(parseInt(App.total_notifications) > 0)
				App.pullActivities(data.activities);

		});
},
pullActivities: function(data)
{
	var badgeCount = 0;
	var messages = [];
	for(var i in data){
			// console.log("badgeCount = " + badgeCount);
			// console.log("data[i] = " + data[i]);
			// console.log("i = " + i);
			badgeCount = badgeCount + data[i];
		}

		if(data[1] > 0)
			messages.push((data[1] > 1) ? (data[1] + " pessoas curtiram seu posts") : "1 pessoa curtiu seu post");

		if(data[2] > 0)
			messages.push((data[2] > 1) ? ("Você tem " + data[2] + " novos seguidores") : "Você tem 1 novo seguidor");

		if(data[3] > 0)
			messages.push((data[3] > 1) ? (data[3] + " pessoas compartilharam seu(s) post(s)") : "1 pessoa compartilhou um post seu");

		if(data[4] > 0)
			messages.push((data[4] > 1) ? (data[4] + " dos seus posts foram escolhidos pelo Editor") : "1 post seu foi escolhido pelo Editor");

		if(data[5] > 0)
			messages.push((data[5] > 1) ? (data[5] + " pessoas comentaram no(s) seu(s) post(s)") : "1 pessoa comentou em um dos seus posts");

		if(data[6] > 0)
			messages.push((data[6] > 1) ? (" Você tem "+ data[6] + " novas mensagens") : "Você tem uma nova mensagem");


		// console.log("pullActivities: ("+ badgeCount +") : " + JSON.stringify(messages));
		if(badgeCount > 0){
			try
			{
				window.plugin.notification.local.add({
						id:         "bynotif",  // A unique id of the notifiction
						message:    messages.join("\n"),  // The message that is displayed
						date:		new Date(),
						badge:      badgeCount,  // Displays number badge to notification
						autoCancel: false // Setting this flag and the notification is automatically canceled when the user clicks it
						// ,ongoing:    false // Prevent clearing of notification (Android only)
					});
			} catch(e) {
					// console.log('error on set local badge');
				}
			}

		},
		facebookLogin: function()
		{
			window.localStorage.token = null;
			console.log("facebookLogin");

		// console.log(FB);

		FB.login(
			function(response) {
				// alert(response);
				console.log("facebookLogin: response: " + JSON.stringify(response));

				// console.log(response);
				
				if (response.status == 'connected') {
					App.logged		= true;
					//navigator.notification.alert('logged in');
					App.authWithFacebookToken();
					App.checkLogin(true);
					App.onLogin(true);
				} else {
					// alert('hei');
					App.notif();
					// navigator.notification.alert('not logged in');
				}
			},
			{ scope: "email,user_birthday,user_location" }
			);
	},
	facebookLogout: function()
	{
		this.userId		= 0;
		App.logged		= false;
		this.userfname	= "";
		this.userfname	= "";
		this.fbtoken    = "";
		this.checkLogin();

		try {
			FB.logout(function(response) {

			});
		} catch(e) {}
	},
	authWithFacebookToken: function()
	{
		var self = this;
		console.log("authWithFacebookToken");
		var fbToken;
		if(window.localStorage.fbtoken == undefined){
			fbToken = FB.getAccessToken();
			window.localStorage.fbtoken = fbToken;
		} else {
			fbToken = window.localStorage.fbtoken;
		}
		Svc.get( BASE_URL + "login/fbMobile?token=" + fbToken, function(data) {
		// Svc.get( BASE_URL + "login/fbMobile?token=" + FB.getAccessToken(), function(data) {
			console.log("authWithFacebookToken: result: " + JSON.stringify(data));
			// if(data.error != undefined){
			// 	if(data.rs != undefined){
			// 		App.notif('Não foi possível criar um novo usuário com seus dados do Facebook. Possivelmente seu email ou nome de usuário já esteja cadastrado em Beautyourself. Tente cadastrar usando seu email');
			// 	} else {
			// 		App.notif('Houve um erro ao estabelecer uma conexão com os servidores do Facebook. Por favor, tente novamente mais tarde.');
			// 	}

			// }
			// else if(data.user_id)
			// {
				if(data.user_id){
					App.userId		= parseInt(data.user_id);
					App.userfname	= data.username;
					App.logged		= true;


					console.log("authWithFacebookToken: logged");

					var newUser = data.newuser;

					App.onLogin(true, newUser);
				} 
			});
	},
	onLogin: function(fb, newuser)
	{
		console.log("onLogin()");
		App.checkLogin(fb);

		if(navigator.splashscreen)
			navigator.splashscreen.hide();

		if(newuser){
			$.mobile.changePage("follow.html");
		} else {
			try { Feed.reset(); } catch(e) {}
			App.load("feed.html");
		}
		// App.getNotifications();
		App.getActivities();

		clearInterval(App.getActivitiesInterval);
		App.getActivitiesInterval = setInterval(function() {
			App.getActivities();
		}, 300000);
	},
	sendNewUser: function(fullname, email, pwd, phone)
	{
		Svc.post(SITE_URL + "join/mobile", { fullname: fullname, email: email, pwd: pwd, phone: phone }, function(data) {
		// alert('apple');
		if(data.msg == null){
			window.localStorage.setItem("codeUserReg", data.code);
				// window.localStorage.codeUserReg = data.code;
				$.mobile.changePage( "completeUser.html" );
				
			} else {
				App.notif(data.msg);
			}
		});
	},
	registerUser: function(username, occup, cat, about){
		Svc.post(SITE_URL + "join/mobileact", { username: username, occupation: occup, occupation_area: cat, about:about, ccode: window.localStorage.getItem('codeUserReg') }, function(data) {
			if(data.msg == null){
				// console.log(data);
				// console.log(App);
				// console.log(this);
				// @TODO: Revisar as clouseres, self === this !== App aqui
				App.userId = data.result.status;
				window.localStorage.token = data.result.token;
				window.localStorage.userType = data.result.usertype;
				$.mobile.changePage( "upPictury.html" );
			} else {
				App.notif(data.msg);
			}				
		});	
	},
	logout: function()
	{
		this.userId		= 0;
		this.userfname	= "";
		App.logged		= false;
		this.userfname	= "";
		window.localStorage.token = false;
		clearInterval(this.getActivitiesInterval);
		this.checkLogin();
		
		if(!App.userId){
			var urlLogout = SITE_URL + "login?a=logout";
			// alert(urlLogout);
			if(window.localStorage.tokenDevideId){
			// alert(urlLogout);
				urlLogout = urlLogout + '&device_id=' + window.localStorage.tokenDevideId;
			// alert(urlLogout);
			}
			// alert(urlLogout);
			Svc.get(urlLogout, function(data) {
			}, false);
			App.load("tour.html");
		}


	},
	load: function(url)
	{
		$.mobile.changePage( APP_URL + url, { transition: "slide"} );
	},
	setTitle: function(str)
	{
		$(".page-header").attr("data-title", str).show().find("h1").html(str);
	},
	fixHeight: function()
	{
		var c = {height:"100%"};
		$("html").css(c);
		$("body").css(c);
		$(".canvas").css(c);
	},
	updateMenu: function(section)
	{

		var it = null;
		if(section == "feed")
			it = "feed";
		else if(section.indexOf("ymag") != -1)
			it = "ymag";
		else if(section == "search")
			it = "search";
		else if(section == "academy" || section == "academy-view")
			it = "academy";

		$("[data-role=footer] li").removeClass("selected");
		if(it)	$("[data-role=footer] li[data-s='"+ it +"']").addClass("selected");

		//this.updateUnreadPosts("ymag", 10);
	},
	updateUnreadPosts: function(name, n)
	{
		if(name)
			window.localStorage[name] = n;
		
		var arr = ["feed", "academy", "ymag"];
		for(var i in arr)
		{
			var val		= window.localStorage[arr[i]] || 0;
			var badge	= val > 0 ? $("<div class='badge'>"+ val +"</div>") : "";
			$("[data-role=footer] li[data-s='"+ arr[i] +"'] a").html(badge);
		}
	},
	getParam: function(name)
	{
		name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
		var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
		results = regex.exec(location.search);
		return results == null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
	},
	getHashPath: function()
	{
		return location.hash.substr(1, location.hash.length).split("/");
	},
	onResize: function()
	{
	},
	shareContent: function(id, title, thumb, link, ownerThumb)
	{

		if(thumb != undefined){
			var messageThumb = '';
			if(ownerThumb != undefined){
				messageThumb = 'Conteudo postado por ' + ownerThumb + ' na #Beautyourself. Vale a pena conferir! #BYS';
			} else {
				messageThumb = 'Conteudo postado na #Beautyourself. Vale a pena conferir! #BYS';
			}
			window.plugins.socialsharing.share(messageThumb, title, thumb, link);
		}

		Svc.post(SITE_URL + "content/share_post", {blist: 0, content: id, shareInProfile: 1}, function(data) {
			// console.log('shared on by');
			$(".btn-share[data-id="+ id +"]").attr("data-value", 1);
			if(data.status > 0)
			{
				$(".btn-share[data-id='"+ id +"']").each(function() {
					var btn = $(this);

					var count = parseInt(btn.find("i").html()) + 1;
					count = Math.max(0, count);

					$(this).find("i").html(count);
				});
			}
		});

		// console.log('shared end');
	},
	follow: function(id, remove, callback)
	{
		if(!this.userId)
		{
			this.openLogin();
			return;
		}
		Svc.post(SITE_URL + "usersMobile/follow", {id: id, remove: remove}, function(data) {

			if(data.status){
				$(".btn-follow[data-id='"+ id +"']").attr("data-value", parseInt(remove) ? 0 : 1);
			}
			if(callback)
				callback(data.status);
		});
	},
	recoverPwd: function(email, callback)
	{
		if(email !== ''){
			Svc.post(SITE_URL + "login/recoveryPassword", { email: email }, function(data) {
		// alert('apple');
		if(data.status < 0){
			App.notif('Email ou usuário não localizado', 'Erro', 'ok', null);
		} else {
			App.notif('Enviamos um email de recuperação para você!', 'Sucesso!', 'voltar', callback);
		}
	});
		} else {
			App.notif('Preencha com o email ou seu nome de usuário', 'Aviso!', 'Corrigir', null);
		}
	},
	notif: function(msg, title, btnName, callback)
	{

		var message;

		switch(msg){
			case 'Usuário e/ou senha inválido(s)':
			title = 'Erro no login';
			message = ' Nome de usuário inexistente ou senha inválida. Por favor tente novamente.';
			break;

			case 'diga seu nome':
			title = 'Erro ao Registrar';
			message = 'Informe Seu Nome';
			break;

			case 'Verifique o enderço de email digitado':
			title = 'Erro ao Registrar';
			message = 'Verifique o enderço de email digitado';
			break;
			
			case 'Senha deve conter pelo menos 5 caracteres':
			title = 'Erro ao Registrar';
			message = 'Senha deve conter pelo menos 5 caracteres';
			break;

			case 'Username em uso':
			title = 'NOME DE USUÁRIO EM USO';
			message = 'Escolha outro nome único de usuário que contenha apenas letras e números';
			break;		

			case 'Email em uso':
			title =  'EMAIL EM USO';
			message = 'Você ou alguém já está cadastrado com este email. Tente fazer login ou se esqueceu a senha, faça um resgate.';
			break;			

			case 'Username invalido':
			title = 'NOME DE USUÁRIO INVÁLIDO';
			message = 'Escolha um nome único de usuário que contenha apenas letras e números.';
			break;			

			case 'Email invalido':
			title = 'EMAIL INVÁLIDO';
			message = 'Verifique e corrija o seu endereço de email.';
			break;			

			case 'missing full name': //register
			title = 'NOME DE USUÁRIO INVÁLIDO';
			message = 'Escolha um nome único de usuário que contenha apenas letras e números.';
			break;			
			
			case 'Senha inválida ou faltando':
			title = 'SENHA INVÁLIDA';
			message = 'Insira uma senha com 4 ou mais caracteres.';
			break;			

			case 'As senhas não conferem':
			case 'Erro ao criar o registro':
			case 'Código de ativação inválido': // complete registration
			case 'Erro ao salvar as informações':
			case 'Erro ao criar o registro':
			case 'sendmail error':
			case '':
			case null:
			case false:
			case undefined:
			message = 'Desculpe, houve um erro no sistema. Tente novamente em alguns instantes.';
			break;
			
			default:
			message = msg;
			break;
		}
		
		if(title === undefined){
			title = 'Erro';
		}

		if(btnName === undefined){
			btnName = 'Ok';
		}
		if(callback === undefined){
			callback = null;
		}

		navigator.notification.alert(
				message,  				// message
				callback,				// callback
				title,					// title
				btnName					// buttonName
				);

	},
	like: function(id, remove, callback)
	{
		if(!this.userId)
		{
			this.openLogin();
			return;
		}
		Svc.post(SITE_URL + "contentMobile/like", {id: id, remove: remove}, function(data) {
			if(data.status)
			{
				$(".btn-like[data-id='"+ id +"']").each(function() {
					var btn = $(this);
					var container = btn.parent().parent();
					var anim = $("<div class='line-unlike-container'></div>");
					container.prepend(anim);
					//anim.css("opacity", 0);
					anim.width(container.find("img").width() - 30);
					anim.height(container.find("img").height());
					anim.css("background-image", "url(img/"+ (parseInt(remove) ? "unlike.png" : "liked.png") +")");
					anim.fadeOut({duration: 1200, complete: function() {
						setTimeout(function() { anim.remove(); }, 1200);
					}});

					//var count = parseInt(btn.attr("data-count")) + (parseInt(remove) > 0 ? -1 : parseInt(btn.attr("data-status")) > 0 ? 0 : 1);
					var count = parseInt(btn.attr("data-count"));

					if(parseInt(remove) > 0)
						count--;
					else if(parseInt(btn.attr("data-status")) < 1)
						count++;



					count = Math.max(0, count);

					$(".btn-like[data-id='"+ id +"']").attr("data-value", parseInt(remove) ? 0 : 1).find("i").html(count);

					if(callback)
						callback(data.status);
				});
}
});
},
plusContent: function(id, remove, callback)
{
	if(!this.userId)
	{
		this.openLogin();
		return;
	}
	this.openPlusContent(id);

},
plusUser: function(id, remove, callback)
{
	if(!this.userId)
	{
		this.openLogin();
		return;
	}
	this.openPlusUser(id);

},
loginModal: null,
openLogin: function()
{
	$.mobile.changePage( "login.html" );
},
openPlusContent: function(idContent)
{
	window.localStorage.setItem("targetContent", idContent);
	$.mobile.changePage( "plus-content.html", {transition: 'none', role: 'dialog'} );
},
openPlusUser: function(idUser)
{
	window.localStorage.setItem("targetUser", idUser);
	$.mobile.changePage( "plus-user.html", {transition: 'none', role: 'dialog'} );
},
	getMobileNotifications: function() //carrega e exibe uma notificação ao abrir o aplicativo, ou se há alguma atualização
	{
		var modal = $(".notf-modal");
		$.get("config.xml", function(data){
			var currentVersion = $(data).find('widget').attr('version');
			Svc.get(SITE_URL + "mobileManager/getNotifications", function(data) {

				if((parseFloat(data.version) > parseFloat(currentVersion)) && data.forceUpdate)
				{
					if(!device) var device = {platform:"iPhone"};
					var url = device.platform == "Android" ? data.googlePlayUrl : data.appleStoreUrl;

					
					modal.append($("<a href='"+ url +"'><img src='"+ SITE_URL + "assets/mobile/imageUpdate.jpg'></a>"));
					modal.show();

				} else if(data.notificationActive) {

					var tag = $("<a><img src='"+ SITE_URL + "assets/mobile/imageNotification.jpg'></a>");
					if(data.notificationUrl)
						tag.attr("href", data.notificationUrl);

					modal.show().append(tag).find(".btn").show().val("Continuar").click(function() {
						modal.hide();
					});
				}
			});
		});
	}
}

PostFileSelect = {
	megaPixImage: null,
	onSelectFile: function(files, profile)
	{
		var self		= this;
		var isSafari	= /Safari/.test(navigator.userAgent);// && /Apple Computer/.test(navigator.vendor);

		if(!files[0]) {
			return;
		}
		if(true)
		{
			this.megaPixImage = new MegaPixImage(files[0]);
			App.showPreLoader();
			setTimeout(function() {
				if(PostFileSelect.megaPixImage.srcImage.naturalWidth < 400 || PostFileSelect.megaPixImage.srcImage.naturalHeight < 400)
				{
					navigator.notification.alert("Imagem muito pequena");
					App.hidePreLoader();
					return;
				}

				if(profile == true){
					App.load("profile-upload.html");
				} else {
					App.load("upload.html");
				}

			}, 700);
		} else {

			App.showPreLoader();
			this.megaPixImage = new DataImage(files[0], function() {
				// App.load("upload.html");
				if(profile == true){
					App.load("profile-upload.html");
				} else {
					App.load("upload.html");
				}
			});
		}
		//this.finish();
	}
};



document.addEventListener('deviceready', function() {

	console.log("deviceready");
	try {
		//navigator.splashscreen.show();
		FB.init({ appId: "645545895477968", nativeInterface: CDV.FB, useCachedDialogs: false });
	} catch (e) {
		console.log(e);
		console.log('error');
	}
}, false);

$(document).ready(function() {
	console.log("document ready");
	$.mobile.defaultPageTransition = "slide";
	$.mobile.hashListeningEnabled = true;
	$.mobile.pushStateEnabled=true;

	(function(d, s, id){
		var js, fjs = d.getElementsByTagName(s)[0];
		if (d.getElementById(id)) {return;}
		js = d.createElement(s); js.id = id;
		js.src = "//connect.facebook.net/en_US/all.js";
		fjs.parentNode.insertBefore(js, fjs);
	}(document, 'script', 'facebook-jssdk'));
	window.fbAsyncInit = function() {
		FB.init({
			appId			:	'645545895477968',
			nativeInterface	:	CDV.FB,
			useCachedDialogs:	false
		});
	};
	// FB.init({ appId: "645545895477968", nativeInterface: CDV.FB, useCachedDialogs: false });
	App.init();
});
